<template>
  <div>
    <div
      v-if="!isNew"
      class="row"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="dataSource.eventData && dataSource.eventData.occurredAt"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="dataSource.eventData && dataSource.eventData.authorTitle"
          :readonly="true"
        />
      </div>
    </div>
    <div
      v-if="isNew || isNewForm"
      class="row"
    >
      <div class="col-xs-12">
          <!-- :value="(formData && formData.comment) || dataSource.eventData.comment" -->
        <ObTextarea
          :value="dataSource.eventData && dataSource.eventData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField('comment', $event)"
        />
      </div>
    </div>
    <template v-if="formData && (!formData.fileUuids || !formData.fileUuids.length) && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="(formData && formData.fileUuids && formData.fileUuids.length) || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'

export default {
  name: 'orderInfoSentForm',
  components: {
    ObInput,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  watch: {
    'formData.fileUuids'(value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource.filesData
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField('fileUuids', null)
        return
      }

      this.onChangeField('fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    }
  },
}
</script>

<style lang="scss" scoped>
  .row-input {
    margin-right: 0;
    margin-left: 0;
    flex-wrap: nowrap;
    &__item {
      width: 212px;
      flex-grow: 2;
      &:not(:last-child) {
        margin-right: 10px;
      }
    }
    &__counter {
      width: 135px;
    }
  }
</style>